#pragma once

#include <Knopf.h>
#include <Bild.h>

#include "Menu.h"
#include "Dialog.h"
#include "DragController.h"

class Player;
class InventoryDragSource;

class Game : public Menu
{
private:
	Framework::Knopf* logout;
	Framework::TextFeld* debug;
	Framework::Array<UIMLDialog*> dialogs;
	Framework::UIMLView* guiView;
	DragController<InventoryDragSource, int>* inventoryDragController;

public:
	// Konstruktor
	Game(Bildschirm* zScreen);
	~Game();

	void updatePosition(Vec3<float> position, bool target, Vec3<int> targetPos);
	void api(char* data);
	void closeCurrentDialog();
	DragController<InventoryDragSource, int>* zInventoryDragController();
};