#pragma once

#include <UIMLView.h>
#include <Either.h>

#include "NetworkAPIProcessor.h"
#include "InventoryView.h"


class ItemBarElement : public Framework::UIMLElement
{
public:
	ItemBarElement();
	//! prft, ob dieses UIML Element fr ein bestimmtes xml Element zustndig ist
	bool isApplicableFor(Framework::XML::Element& element) override;
	//! erstellt eine neue Zeichnung zu einem gegebenen xml Element
	Framework::Zeichnung* parseElement(Framework::XML::Element& element, Framework::UIMLContainer& generalFactory) override;
	//! wendet die layout parameter zu einer Zeichnung an
	void layout(Framework::XML::Element& element, Framework::Zeichnung& z, int pWidth, int pHeight, Framework::UIMLContainer& generalLayouter) override;
};

class ItemBarView : public Framework::ZeichnungHintergrund, public NetworkAPIProcessor
{
private:
	Framework::Text id;
	int rowSize;
	int targetEntity;
	Framework::Text slotNameFilter;
	Framework::Array<SlotInfo>* slots;
	int leftHandPos;

public:
	ItemBarView(Framework::Text id, int rowSize, int targetEntity, Framework::Text slotNameFilter);
	~ItemBarView();
	void api(char* message) override;
	void render(Framework::Bild& rObj) override;
};